
object Test {

  def printStream[A] (st:Stream[A]):Unit = 
    if (st.hasElement()) {
      println("  " + st.head());
      printStream(st.tail())
    } else
      ()

  def sumStream (st:Stream[Int]):Int = 
    if (st.hasElement())
      st.head() + sumStream(st.tail())
    else 
      0

  def main (argv:Array[String]):Unit = run()

  def run ():Unit = {
    val L1:List = List.cons(33,List.cons(66,List.cons(99,List.empty())))
    println("L1 = " + L1)
    println("First of L1 = " + L1.first())
    println("Rest of L1 = " + L1.rest())
    println("Length of L1 = " + L1.length())

    println("Printing L1 = ")
    printStream[Int](L1)
    println("Sum L1 = " + sumStream(L1))
  }
}
